/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2004 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_DESKTOPTEXTURE_H__DF589CF7_3C13_487E_A0B3_34ADA89C0C81__INCLUDED_)
#define AFX_DESKTOPTEXTURE_H__DF589CF7_3C13_487E_A0B3_34ADA89C0C81__INCLUDED_

#include "Texture.h"

class DesktopTexture : public Texture 
{
public:

	DesktopTexture();
	virtual ~DesktopTexture();

	void configure(const string &prefix, const string &subKey);
	bool apply(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType);
	bool applyAnim(HDC hDC, int x, int y, int width, int height, int transparencyMode, int imageType, int count) { return false; };

	bool isTransparencyNeeded() { return true; };
	bool isAlphaMapNeeded() { return false; };

private:

	bool useSmallIcon;

	HICON hIcon;
	HICON hIconSelected;

	HDC memoryColorIconDC;
	HBITMAP memoryColorIconBitmap;

	HDC memoryColorIconSelectedDC;
	HBITMAP memoryColorIconSelectedBitmap;

	HDC memoryMaskIconDC;
	HBITMAP memoryMaskIconBitmap;

	string curName;

	int iconSize;
	int iconTextPosition;
	int iconTextSpacing;

	COLORREF iconTextBackground;
	COLORREF iconTextBackgroundLight;
	COLORREF iconTextBackgroundDark;

	int _saturation;
	int _hueIntensity;
	COLORREF _hueColor;
};

#endif // !defined(AFX_DESKTOPTEXTURE_H__DF589CF7_3C13_487E_A0B3_34ADA89C0C81__INCLUDED_)
