/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2004 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#include "StdAfx.h"
#include "Tasks.h"

StringList tasksList;
bool activeTaskOnly;

BOOL CALLBACK TaskEnumWindowsProc(HWND hwnd, LPARAM lParam);

BOOL CALLBACK TaskEnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	if ( IsAppWindow(hwnd) && (activeTaskOnly ? !IsIconic(hwnd) : true) )
	{
		char pszWindowText[1024];
		GetWindowText(hwnd, pszWindowText, sizeof(pszWindowText));

		tasksList.insert(tasksList.end(), pszWindowText);
	}

	return TRUE;
}

string Tasks::UpdateTasks(string sep, bool first)
{
	tasksList.clear();
	// add the contents

	activeTaskOnly = first;

	EnumWindows(TaskEnumWindowsProc, (LPARAM)this);

	string result = "";
	if (!first)
	{
		for(StringListIterator it = tasksList.begin(); it != tasksList.end(); it++)
		{
			result.append((*it));
			it++;
			if (it != tasksList.end())
				result.append(sep);
			it--;
		}
	}
	else if (tasksList.begin() != tasksList.end())
		result.append( (*tasksList.begin()) );

	return result;

}